Change VPP repo URL
[csit.git] / bootstrap-verify-perf.sh
index a4d5194..c6619f9 100755 (executable)
 set -x
 
 # Space separated list of available testbeds, described by topology files
-TOPOLOGIES="topologies/available/lf_testbed2-710-520.yaml"
+TOPOLOGIES="topologies/available/lf_testbed1-X710-X520.yaml \
+            topologies/available/lf_testbed2-X710-X520.yaml \
+            topologies/available/lf_testbed3-X710-X520.yaml"
+
+VPP_STABLE_VER="16.09-rc0~85-gc71c426~b252_amd64"
+VPP_REPO_URL="https://nexus.fd.io/content/repositories/fd.io.master.ubuntu.trusty.main/io/fd/vpp/"
 
 # Reservation dir
 RESERVATION_DIR="/tmp/reservation_dir"
 INSTALLATION_DIR="/tmp/install_dir"
 
-# Jenkins VPP deb paths (convert to full path)
-VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
+PYBOT_ARGS="--noncritical MULTI_THREAD"
+
+ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
+
+# If we run this script from CSIT jobs we want to use stable vpp version
+if [[ ${JOB_NAME} == csit-* ]] ;
+then
+    mkdir vpp_download
+    cd vpp_download
+    #download vpp build from nexus and set VPP_DEBS variable
+    wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dpdk-dev/${VPP_STABLE_VER}/vpp-dpdk-dev-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${VPP_STABLE_VER}/vpp-dpdk-dkms-${VPP_STABLE_VER}.deb" || exit
+    wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}.deb" || exit
+    VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
+    PYBOT_ARGS="${PYBOT_ARGS} --exitonfailure"
+    cd ..
+
+# If we run this script from vpp project we want to use local build
+elif [[ ${JOB_NAME} == vpp-* ]] ;
+then
+    #use local packages provided as argument list
+    # Jenkins VPP deb paths (convert to full path)
+    VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
+else
+    echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
+    exit 1
+fi
 
 CUR_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 WORKING_TOPOLOGY=""
@@ -31,7 +64,7 @@ export PYTHONPATH=${CUR_DIR}
 sudo apt-get -y update
 sudo apt-get -y install libpython2.7-dev python-virtualenv
 
-virtualenv env
+virtualenv --system-site-packages env
 . env/bin/activate
 
 echo pip install
@@ -54,14 +87,14 @@ while :; do
         break
     fi
 
-    # Wait 10 - 30 sec. before next try
-    SLEEP_TIME=$[ ( $RANDOM % 20 ) + 10 ]s
+    # Wait ~3minutes before next try
+    SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
     echo "Sleeping ${SLEEP_TIME}"
     sleep ${SLEEP_TIME}
 done
 
 function cancel_all {
-    python ${CUR_DIR}/resources/tools/topo_installation.py -c -t $1
+    python ${CUR_DIR}/resources/tools/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
     python ${CUR_DIR}/resources/tools/topo_reservation.py -c -t $1
 }
 
@@ -79,14 +112,106 @@ else
     exit 1
 fi
 
-if [ ! -z "$TEST_TAG" ]; then
-# run specific performance tests by tag if variable is set
-    pybot -L TRACE \
-        -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-        -i "${TEST_TAG,,}" tests/
-else
-# run full performance test suite
-    pybot -L TRACE \
-        -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-        -s performance tests/
+case "$TEST_TAG" in
+    # run specific performance tests based on jenkins job type variable
+    PERFTEST_LONG )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -i perftest_long \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_SHORT )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -i perftest_short \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_LONG_BRIDGE )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s "performance.Long_Bridge_Domain*" \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_LONG_IPV4 )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s "performance.Long_IPv4*" \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_LONG_IPV6 )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s "performance.Long_IPv6*" \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_LONG_XCONNECT )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s "performance.Long_Xconnect*" \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_LONG_XCONNECT_DOT1Q )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s "performance.Long_Xconnect_Dot1q*" \
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_NDR )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s performance -i NDR \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    PERFTEST_PDR )
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s performance -i PDR \
+              tests/
+        RETURN_STATUS=$(echo $?)
+        ;;
+    * )
+        # run full performance test suite and exit on fail
+        pybot ${PYBOT_ARGS} \
+              -L TRACE \
+              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
+              -s performance \
+              tests/
+        RETURN_STATUS=$(echo $?)
+esac
+
+# Pybot output post-processing
+echo Post-processing test data...
+
+python ${CUR_DIR}/resources/tools/robot_output_parser.py \
+       -i ${CUR_DIR}/output.xml \
+       -o ${CUR_DIR}/output_perf_data.xml \
+       -v ${VPP_STABLE_VER}
+if [ ! $? -eq 0 ]; then
+    echo "Parsing ${CUR_DIR}/output.xml failed"
 fi
+
+# Archive artifacts
+mkdir archive
+for i in ${ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
+done
+
+echo Post-processing finished.
+
+exit ${RETURN_STATUS}